/* add parameter info
functions:
{ {[INPUT ] | OUTPUT | INPUT-OUTPUT} param-name AS data-type
  | [ INPUT ] TABLE FOR temp-table-name
  | { OUTPUT | INPUT-OUTPUT } TABLE FOR temp-table-name [ APPEND ]
  | BUFFER buffer-name FOR database-table-name
}

procedures:
DEFINE { INPUT | OUTPUT | INPUT-OUTPUT | RETURN }
   PARAMETER parameter
      { { LIKE field } | { AS [ HANDLE [ TO ] ] datatype } }
      [ [ NOT ] CASE-SENSITIVE ]
      [ FORMAT string ]
      [ DECIMALS n ]
      [ INITIAL constant ]
      [ COLUMN-LABEL label ]
      [ LABEL string ]
      [ NO-UNDO ]

DEFINE PARAMETER BUFFER buffer FOR table [ PRESELECT ] [ LABEL label ]

DEFINE { INPUT | INPUT-OUTPUT } PARAMETER TABLE FOR temp-table-name [ APPEND ]

DEFINE { OUTPUT } PARAMETER TABLE FOR temp-table-name

DEFINE { INPUT | INPUT-OUTPUT } PARAMETER TABLE-HANDLE [ FOR ] temp-table-handle [ APPEND ]

DEFINE { OUTPUT } PARAMETER TABLE-HANDLE [ FOR ] temp-table-handle
*/

def temp-table tt1 field f1 as int.
def temp-table tt1-tt field f1 as int.

function f0 returns int (i1 as int, input i2 as int, output ch1 as char, input-output d1 as decimal):
  return ?.
end.
function f1a returns char (table for tt1, input table for tt1, output table for tt1, input-output table for tt1, input-output table for tt1 append, input table for tt1 append, buffer cs-test2 for cs-test):
  return ?.
end.
function f1b returns char (table for tt1):
  return ?.
end.
function f1c returns char (input table for tt1):
  return ?.
end.
function f1d returns char (output table for tt1):
  return ?.
end.
function f1e returns char (input-output table for tt1):
  return ?.
end.
function f1f returns char (input-output table for tt1 append):
  return ?.
end.
function f1g returns char (input table for tt1 append):
  return ?.
end.
function f1h returns char (buffer cs-test2 for cs-test):
  return ?.
end.
function f1i returns handle:
  return ?.
end.

procedure proc0.
   define input parameter p2 as char.
   define output parameter p3 as char.
   define input-output parameter p4 as char.
   define input parameter p5 like tt1.f1.
end.

procedure proc1 external "some-lib.dll".
   define return parameter p5 as character.
end.

procedure proc2a.
   define parameter buffer book2 for book.
   define parameter buffer cs-test2 for cs-test.
   
   define input parameter table for tt1.
   define input parameter table for tt1-tt.
   define input-output parameter table for tt1.
   define input parameter table for tt1 append.
   define input-output parameter table for tt1 append.
   
   define output parameter table for tt1.
end.

procedure proc2b.
   define parameter buffer book2 for book.
end.

procedure proc2c.
   define input parameter table for tt1.
end.

procedure proc2d.
   define input-output parameter table for tt1.
end.

procedure proc2e.
   define input parameter table for tt1 append.
   define input-output parameter table for tt1 append.
   
   define output parameter table for tt1.
end.

procedure proc2f.
   define input-output parameter table for tt1 append.
end.

procedure proc2g.
   define output parameter table for tt1.
end.

procedure proc2h.
   return ?.
end.

def var h as handle.
procedure procs in super.
end.

function funcs returns int in super.
function funch returns int in h.

def var i as int.
def var ch as char.
def stream rpt.

output stream rpt to get_signature.log.
export stream rpt this-procedure:internal-entries.

do i = 1 to num-entries(this-procedure:internal-entries, ","):
  ch = entry(i, this-procedure:internal-entries, ",").
  export stream rpt ch this-procedure:get-signature(ch).
end.

export stream rpt this-procedure:name this-procedure:get-signature("").

output stream rpt close.