/*
if proc0 is defined in super and internal, then the in super proc0 is hidden (internal proc0 is executed)
if proc0.p is defined external and in super, then the in super proc0.p is hidden (external proc0.p is executed) 
if f0 is defined in super and local, then the in super f0 is hidden (local f0 is executed)
if f0 is defined in handle and local, then local f0 is hidden (in handle is executed)
if f0 is defined in handle and in super, then the in super is hidden
if f0 is defined in handle, local and in super, then the in super and local are hidden (in handle is executed)
this-procedure:internal-entries will always show only one function/procedure with a given name

compile errors appear only if local function/procedure is defined first and then is followed by IN handle or IN SUPER function/procedure
if multiple IN handle function definitions, only first one survives
frame definition is collected from local function/procedure, even if the definition gets dropped
all function/procedure definitions must have the same number of parameters and types, if they have the same name. 
*/
def temp-table gg1 field f1 as int.
def temp-table gg1-tt field f1 as int.

def var h as handle.
def var h2 as handle.
def var h3 as handle.
def var h4 as handle.
procedure proc0 in super.
end.
procedure proc0.
   message "proc0 internal".
end.
procedure proc2.
   message "proc2 internal".
end.
run proc0.

function f0 returns int in super.
function f0 returns int in h.
function f0 returns int in h2.
function f0 returns int:
   message "f0 internal".
   return ?.
end.
function f2 returns int:
   message "f2 internal".
end.
f0().

/* TODO: test with parameters and different handles (which one gets executed ???) */
function fa0 returns int in h.
function fa0 returns int in h2.
function fa0 returns int in h3.
function fa0 returns int in h4.
fa0().

/* TODO: test with parameters */
function fb0 returns int in super.
function fb0 returns int in super.
function fb0 returns int in super.
function fb0 returns int in super.
function fb0 returns int in super.
fb0().

/* TODO: test with parameters */
procedure procb0 in super.
end.
procedure procb0 in super.
end.
procedure procb0 in super.
end.
procedure procb0 in super.
end.
do on stop undo, leave:
   run procb0.
end.

/* 4GL allows the same name for procedures and functions defined in super/in handle */
procedure whatami in super.
end.
function whatami returns int in super.
function whatami returns int in h.
function whatami returns int in h2.
do on stop undo, leave:
   run whatami.
end.
whatami().

function whatami3 returns int in super.
function whatami3 returns int in h.
function whatami3 returns int in h2.
function whatami3 returns int.
   return ?.
end.
whatami3().

function whatami2a returns int in super.
function whatami2a returns int in h.
function whatami2a returns int in h2.
whatami2a().

function whatami2b returns int in super.
function whatami2b returns int.
   return ?.
end.
whatami2b().

function whatami2c returns int in h.
function whatami2c returns int in h2.
function whatami2c returns int.
   return ?.
end.
whatami2c().

procedure whatami4 in super.
end.
procedure whatami4.
end.
run whatami4.

message this-procedure:internal-entries.